#ifndef OPS_H
#define OPS_H

#include "main.h"

enum {
  OP_BR = 0, /* branch */
  OP_ADD,    /* add  */
  OP_LD,     /* load */
  OP_ST,     /* store */
  OP_JSR,    /* jump register */
  OP_AND,    /* bitwise and */
  OP_LDR,    /* load register */
  OP_STR,    /* store register */
  OP_RTI,    /* unused */
  OP_NOT,    /* bitwise not */
  OP_LDI,    /* load indirect */
  OP_STI,    /* store indirect */
  OP_JMP,    /* jump */
  OP_RES,    /* reserved (unused) */
  OP_LEA,    /* load effective address */
  OP_TRAP    /* execute trap */
};

void op_br(u16 instr);
void op_add(u16 instr);
void op_ld(u16 instr);
void op_st(u16 instr);
void op_jsr(u16 instr);
void op_and(u16 instr);
void op_ldr(u16 instr);
void op_str(u16 instr);
// RTI unused
void op_not(u16 instr);
void op_ldi(u16 instr);
void op_sti(u16 instr);
void op_jmp(u16 instr);
// RES unused
void op_lea(u16 instr);
// TRAP is handled in main()

#endif
